import { RouteHelper } from '../core'

import ForumView from './views/forum/forum-view.vue'
import ForumSectionView from './views/section/section-view.vue'
import ForumTopicCreateView from './views/topic-create/topic-create-view.vue'
import ForumTopicsView from './views/topics/topics-view.vue'
import ForumTopicView from './views/topic/topic-view.vue'
import ForumTopicEditView from './views/topic-edit/topic-edit-view.vue'
import ForumSubscriptionsView from './views/subscriptions/subscriptions-view.vue'
import ForumPostsView from './views/posts/posts-view.vue'
import ForumPostEditView from './views/post-edit/post-edit-view.vue'

const components = [
  ForumView,
  ForumSectionView,
  ForumTopicCreateView,
  ForumTopicsView,
  ForumTopicView,
  ForumTopicEditView,
  ForumSubscriptionsView,
  ForumPostsView,
  ForumPostEditView,
]

const meta = [
  {
    id: null,
    sortOrder: 1,
    name: 'forum-forum',
    parent: null,
    path: '/forum',
    title: 'Forum',
    menuItem: false,
    iconClass: 'bi bi-collection-fill',
    component: 'ForumView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-section',
    parent: 'forum-forum',
    path: '/forum/sections/:codeName',
    title: 'Section',
    menuItem: false,
    iconClass: 'bi bi-folder2-open',
    component: 'ForumSectionView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-topics',
    parent: 'forum-section',
    path: '/forum/topics',
    title: 'Topics',
    menuItem: false,
    iconClass: 'bi bi-folder2-open',
    component: 'ForumTopicsView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-topic-create',
    parent: 'forum-section',
    path: '/forum/create-topic',
    title: 'Create Topic',
    menuItem: false,
    iconClass: 'bi bi-file-earmark-text',
    component: 'ForumTopicCreateView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-topic',
    parent: 'forum-section',
    path: '/forum/topics/:alias',
    title: 'View Topic',
    menuItem: false,
    iconClass: 'bi bi-file-earmark-text',
    component: 'ForumTopicView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-topic-edit',
    parent: 'forum-topic',
    path: '/forum/topics/:alias/edit',
    title: 'View Topic',
    menuItem: false,
    iconClass: 'bi bi-pencil-fill',
    component: 'ForumTopicEditView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-subscriptions',
    parent: 'identity-account',
    path: '/forum/subscriptions',
    title: 'Subscriptions',
    menuItem: true,
    iconClass: 'bi bi-star-fill',
    component: 'ForumSubscriptionsView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-posts',
    parent: 'identity-user-profile',
    path: '/forum/posts',
    title: 'Posts',
    menuItem: false,
    iconClass: 'bi bi-chat-left-text',
    component: 'ForumPostsView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'forum-post-edit',
    parent: 'forum-topic',
    path: '/forum/posts/:postId/edit',
    title: 'Edit Post',
    menuItem: false,
    iconClass: 'bi bi-pencil-fill',
    component: 'ForumPostEditView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
]

export default meta.map((x) => RouteHelper.metaToRoute(x, components))
